<p align="left">
  <img src="media/logo.png" width="50%"/>
</p>

[![Build Status](https://app.travis-ci.com/caleblareau/mgatk.svg?branch=master)](https://app.travis-ci.com/caleblareau/mgatk)
[![PyPI version](https://badge.fury.io/py/mgatk.svg)](https://pypi.python.org/pypi/mgatk)
[![License: MIT](https://img.shields.io/badge/License-MIT-blue.svg)](https://opensource.org/licenses/MIT)
[![Downloads](https://pepy.tech/badge/mgatk/month)](https://pepy.tech/project/mgatk)

[Source code is made freely available](http://github.com/caleblareau/mgatk)
and a packaged install version is provided through [PyPi](https://pypi.python.org/pypi/mgatk/).
<br>

## About
This repository houses the **mgatk** package, a python-based command line interface for
processing `.bam` files with mitochondrial reads and generating high-quality heteroplasmy 
estimation from sequencing data. This package places a special emphasis on mitochondrial
genotypes generated from single-cell genomics data, primarily `mtscATAC-seq`, but is generally
applicable across other assays. 
<br>

Check out the [**mgatk** documentation](https://github.com/caleblareau/mgatk/wiki) for more 
information and user guides. 

## Contact

The **mgatk** package was developed and is maintained by [Caleb Lareau](https://profiles.stanford.edu/caleb-lareau).

<br><br>

#!/usr/bin/env Rscript
suppressMessages(suppressWarnings(library(dplyr)))
suppressMessages(suppressWarnings(library(data.table)))

args <- commandArgs(trailingOnly = TRUE)

in_file = args[1]
out_file = args[2]
read_length = args[3]
window_far = args[4]
window_near = args[5]
left_coordinates = args[6]
right_coordinates = args[7]

# steps to process deletion coordinates
process_coordinate <- function(string){
  as.numeric(strsplit(string, ",")[[1]])
}
read_length <- as.numeric(read_length)
window_far <- as.numeric(window_far)
window_near <- as.numeric(window_near)
left <- process_coordinate(left_coordinates)
right <- process_coordinate(right_coordinates)

# Key function to do the deletion calling
compute_heteroplasmy_deletion <- function(file, breakpoint_l, breakpoint_r){
  
  # Define windows based on breakpoints
  left_window <- (breakpoint_l-(read_length-window_far)):(breakpoint_l-window_near)
  right_window <- (breakpoint_r+window_near):(breakpoint_r+(read_length-window_far))
  
  # make cell name variable
  cell_id <- gsub(".readStats.tsv", "", basename(file))
  cell_id <- gsub(".qc$", "", cell_id)
  
  # read in stats data and rename variables
  renames <- c("start", "end", "lc", "rc", "clip_pos", "read_name", "barcode", "n_clipped")
  read_stats <- fread(input = file) %>% rename_all(~renames)
  read_stats[is.na(read_stats)] <- 0
  
  # clipped reads
  read_stats <- read_stats %>%
    filter(start %in% left_window | end %in% right_window) %>%
    filter(clip_pos %in% c((breakpoint_l), (breakpoint_r), 0))
  
  # calculate heteroplasmy; ifelse so each sequenced molecule only counts once
  out <- read_stats %>%
    group_by(read_name) %>%
    summarise(total = sum(lc) + sum(rc)) %>%
    mutate(total = ifelse(total > 0, 1, 0)) %>%
    summarise(cell = cell_id, heteroplasmy = round(sum(100*total)/n(),2),
              reads_del = sum(total), reads_wt = n() - sum(total), reads_all = n(),
              total_clipped_bases = NA) %>%
    mutate(deletion = paste0("del", as.character(breakpoint_l), "-", as.character(breakpoint_r)), what = "naive")  

  # reads with barcode
  bar_reads <- read_stats %>% filter(barcode) %>%
    pull(read_name)
  
  # calculate heteroplasmy with slight modifications
  out_quant <- read_stats %>%
    filter(!(read_name %in% bar_reads)) %>%
    group_by(read_name) %>%
    mutate(count = n(),
           total = sum(lc) + sum(rc)) %>%
    ungroup() %>%
    filter((count == total | total == 0)) %>%
    dplyr::select(-count, -total) %>%
    group_by(read_name) %>%
    summarise(total = sum(lc) + sum(rc),
              sum_lc = sum(lc), sum_rc = sum(rc),
              n_clipped = max(n_clipped)) %>%
    mutate(total = ifelse(total > 0, 1, 0)) %>%
    summarise(cell = cell_id, heteroplasmy = round(sum(100*total)/n(),2),
              reads_del = sum(total), reads_wt = n() - sum(total), reads_all = n(), 
              total_clipped_bases = sum(n_clipped)) %>%
    mutate(deletion = paste0("del", as.character(breakpoint_l), "-", as.character(breakpoint_r)),  what = "improved")
  
  data.frame(rbind(out_quant, out))

}

heteroplasmy_multiple <- function(in_file, bps1, bps2){
  lapply(1:min(length(bps1), length(bps2)), function(i){
    compute_heteroplasmy_deletion(in_file, bps1[i], bps2[i])
  }) %>% rbindlist() %>% data.frame()
}

het_mult_out <- heteroplasmy_multiple(in_file, left, right) 

# Process and export
write.table(
  het_mult_out, file = out_file,
  row.names = FALSE, col.names = FALSE, sep = "\t", quote = FALSE
)

#!/usr/bin/env Rscript
suppressMessages(suppressWarnings(library(tools)))
suppressMessages(suppressWarnings(library(Matrix)))
suppressMessages(suppressWarnings(library(SummarizedExperiment)))
suppressMessages(suppressWarnings(library(GenomicRanges)))
suppressMessages(suppressWarnings(library(data.table)))

options(warn=-1)

if(FALSE){
  
}

# Explicit import of mgatk output files
importMito.explicit <- function(Afile, Cfile, Gfile, Tfile,
                                coverageFile, depthFile, referenceAlleleFile,
                                mitoChr = "chrM"){
  
  variantFiles <- list(Afile, Cfile, Gfile, Tfile)
  metaFiles <- list(coverageFile, depthFile, referenceAlleleFile)
  
  nullout <- lapply(c(variantFiles, metaFiles), function(file){
    stopifnot(length(file) == 1)
  })
  
  # Set up downstream processing including robust ordering
  # The coverage file could have slightly more variants /
  # individual samples depending on the calls, so base it
  # of of them
  importDT <- function(file){
    if(tools::file_ext(file) == "gz"){
      cov <- suppressMessages(data.table::fread(paste0("zcat < ", file), stringsAsFactors = TRUE))
    } else if(tools::file_ext(file) %in% c("txt", "csv", "tsv")){
      cov <- suppressMessages(data.table::fread(paste0(file), stringsAsFactors = TRUE))
    } else{
      stop("Provide a valid file format for the  file (.gz, .txt, .csv, or .tsv)")
    }
  }
  
  cov <- importDT(coverageFile)
  
  # Make a long matrix of bq and Counts for non-reference alleles
  ref <- importDT(referenceAlleleFile)
  maxpos <- max(ref[[1]])
  
  samplesOrder <- levels(cov[[2]])
  maxsamples <- length(samplesOrder)
  
  # make coverage a sparse matrix
  covmat <- Matrix::sparseMatrix(
    i = c(cov[[1]], maxpos), 
    j = c(as.numeric(cov[[2]]), maxsamples), 
    x = c(cov[[3]], 0)
  )
  remove(cov)
  
  # Import Counts and qualities
  importSMs <- function(file){
    # fread the individual variant calls in
    if(tools::file_ext(file) == "gz"){
      dt <-  suppressMessages(data.table::fread(paste0("zcat < ", file), stringsAsFactors = TRUE))
    } else if(tools::file_ext(file) %in% c("txt", "csv", "tsv")){
      dt <-  suppressMessages(data.table::fread(paste0(file), stringsAsFactors = TRUE))
    } else{
      stop("Provide a valid file format for the alt allele abundances (.gz, .txt, .csv, or .tsv)")
    }
    
    # Encore same ordering as coverage for the sample factor 
    dt[[2]] <- factor(as.character(dt[[2]]), levels = samplesOrder)
    
    if(dim(dt)[2] == 6){
      # including base qualities
      
      qual_fw <- Matrix::sparseMatrix(
        i = c(dt[[1]],maxpos),
        j = c(as.numeric(dt[[2]]), maxsamples),
        x = c(dt[[4]],0)
      )
      
      qual_rev <- Matrix::sparseMatrix(
        i = c(dt[[1]],maxpos),
        j = c(as.numeric(dt[[2]]), maxsamples),
        x = c(dt[[6]],0)
      )
      
      count_fw_idx <- 3
      count_rev_idx <- 5
      base_quals = TRUE
      
    } else {
      # No base qualities are emitted
      count_fw_idx <- 3
      count_rev_idx <- 4
      base_quals = FALSE
    }
    
    counts_fw <- Matrix::sparseMatrix(
      i = c(dt[[1]],maxpos),
      j = c(as.numeric(dt[[2]]), maxsamples),
      x = c(dt[[count_fw_idx]],0)
    )
    
    counts_rev <- Matrix::sparseMatrix(
      i = c(dt[[1]],maxpos),
      j = c(as.numeric(dt[[2]]), maxsamples),
      x = c(dt[[count_rev_idx]],0)
    )
    
    remove(dt)
    
    # Return more substantial list only if there are base qualities involved
    if(base_quals){
      return(list("counts_fw" = counts_fw, "qual_fw" = qual_fw,
                  "counts_rev" = counts_rev, "qual_rev" = qual_rev))
    } else {
      return(list("counts_fw" = counts_fw, 
                  "counts_rev" = counts_rev))
    }
  }
  
  ACGT <- lapply(variantFiles, importSMs)
  names(ACGT) <- c("A", "C", "G", "T")
  
  # Create colData
  depth <- data.frame(importDT(depthFile))
  sdf <- merge(data.frame(sample = samplesOrder), depth, by.x = "sample", by.y = "V1")
  rownames(sdf) <- samplesOrder
  colnames(sdf) <- c("sample", "depth")
  
  # Make row Ranges for each object
  row_g_cov <- GenomicRanges::GRanges(seqnames = mitoChr,
                                      IRanges::IRanges(1:maxpos, width = 1))
  GenomicRanges::mcols(row_g_cov) <- data.frame(refAllele = toupper(ref[[2]][1:maxpos]))
  
  # Export a signac object
  refallele <- data.frame(
    pos = 1:maxpos,
    ref = as.character(toupper(ref[[2]][1:maxpos])),
    stringsAsFactors = FALSE
  )
  signac_counts <-  rbind(ACGT[["A"]][["counts_fw"]],  ACGT[["C"]][["counts_fw"]],
                          ACGT[["T"]][["counts_fw"]],  ACGT[["G"]][["counts_fw"]],
                          ACGT[["A"]][["counts_rev"]],  ACGT[["C"]][["counts_rev"]],
                          ACGT[["T"]][["counts_rev"]],  ACGT[["G"]][["counts_rev"]])
  
  signac_object <- list("counts" = signac_counts, "depth" = sdf, "refallele" = refallele)
  
  # Make summarized experiments 
  if(length(ACGT[["A"]]) > 2){
    # With base qualities
    SE <- SummarizedExperiment::SummarizedExperiment(
      assays = list(
        "A_counts_fw" = ACGT[["A"]][["counts_fw"]], "A_counts_rev" = ACGT[["A"]][["counts_rev"]],
        "A_qual_fw" = ACGT[["A"]][["qual_fw"]], "A_qual_rev" = ACGT[["A"]][["qual_rev"]],
        "C_counts_fw" = ACGT[["C"]][["counts_fw"]], "C_counts_rev" = ACGT[["C"]][["counts_rev"]],
        "C_qual_fw" = ACGT[["C"]][["qual_fw"]], "C_qual_rev" = ACGT[["C"]][["qual_rev"]],
        "G_counts_fw" = ACGT[["G"]][["counts_fw"]], "G_counts_rev" = ACGT[["G"]][["counts_rev"]],
        "G_qual_fw" = ACGT[["G"]][["qual_fw"]], "G_qual_rev" = ACGT[["G"]][["qual_rev"]],
        "T_counts_fw" = ACGT[["T"]][["counts_fw"]], "T_counts_rev" = ACGT[["T"]][["counts_rev"]],
        "T_qual_fw" = ACGT[["T"]][["qual_fw"]], "T_qual_rev" = ACGT[["T"]][["qual_rev"]],
        "coverage" =  covmat
      ),
      colData = S4Vectors::DataFrame(sdf),
      rowData = row_g_cov
    )
  } else {
    # Without base qualities
    SE <- SummarizedExperiment::SummarizedExperiment(
      assays = list(
        "A_counts_fw" = ACGT[["A"]][["counts_fw"]], "A_counts_rev" = ACGT[["A"]][["counts_rev"]], 
        "C_counts_fw" = ACGT[["C"]][["counts_fw"]], "C_counts_rev" = ACGT[["C"]][["counts_rev"]], 
        "G_counts_fw" = ACGT[["G"]][["counts_fw"]], "G_counts_rev" = ACGT[["G"]][["counts_rev"]],
        "T_counts_fw" = ACGT[["T"]][["counts_fw"]], "T_counts_rev" = ACGT[["T"]][["counts_rev"]], 
        "coverage" =  covmat
      ),
      colData = S4Vectors::DataFrame(sdf),
      rowData = row_g_cov
    )
  }
  return(list(SE, signac_object))
}

#---------------------------------------
# Function to parse the folder hierarchy
#---------------------------------------

importMito <- function(folder, ...){
  
  files <- list.files(folder, full.names = TRUE)
  
  checkGrep <- function(hit){
    if(length(hit) != 1){
      stop("Improper folder specification; file missing / extra file present. See documentation")
    } else {
      return(hit)
    }
  }
  
  # Set up file paths
  Afile <- files[checkGrep(grep(".A.txt", files))]
  Cfile <- files[checkGrep(grep(".C.txt", files))]
  Gfile <- files[checkGrep(grep(".G.txt", files))]
  Tfile <- files[checkGrep(grep(".T.txt", files))]
  coverageFile <- files[checkGrep(grep(".coverage.txt", files))]
  depthFile <- files[checkGrep(grep(".depthTable.txt", files))]
  referenceAlleleFile <- files[checkGrep(grep("refAllele.txt", files))]
  
  # Parse out the mitochondrial genome name from the file name
  sv <- strsplit(gsub("_refAllele.txt", "", basename(referenceAlleleFile)), split = "[.]")[[1]]
  mitoChr <- sv[length(sv)]
  
  SElist <- importMito.explicit(Afile, Cfile, Gfile, Tfile,
                                coverageFile, depthFile, referenceAlleleFile, mitoChr, ...)
  return(SElist)
}


#-----------------
# Command line i/o
#-----------------
args <- commandArgs(trailingOnly = TRUE)
folder <- args[1]
name <- args[2]

SElist <- importMito(folder)
saveRDS(SElist[[1]], file = paste0(folder, "/", name, ".rds"))
saveRDS(SElist[[2]], file = paste0(folder, "/", name, ".signac.rds"))

library(dplyr)
library(Matrix)
library(tidyr)
library(optparse)
library(data.table)

option_list <- list(
  make_option(c("-i","--input"),type="character",help="input MGATK directory",metavar="file"),
  make_option(c("-o","--output"),type="character",help="output directory to be used as input for cellbender",metavar="file"),
  make_option("--n_cells_conf_detected",type="integer",default=2,help="n_cells_conf_detected to select variable positions [%default]",metavar="integer"),
  make_option("--strand_correlation",type="double",default=.5,help="strand_correlation to select variable positions [%default]",metavar="integer"),
  make_option("--vmr",type="double",default=.001,help="vmr to select variable positions [%default]",metavar="integer")
)

opt_parser <- OptionParser(option_list = option_list)
options <- parse_args(opt_parser)

if (is.null(options$input)) {
  print_help(opt_parser)
  stop("please supply input directory",call.=FALSE)
}

if (is.null(options$output)) {
  print_help(opt_parser)
  stop("please supply output directory",call.=FALSE)
}

# copy-and-paste a few of Signac's functions for convenience

SparseRowVar <- function(x) {
  return(rowSums(x = (x - rowMeans(x = x)) ^ 2) / (dim(x = x)[2] - 1))
}

SparseMatrixFromBaseCounts <- function(basecounts, cells, dna.base, maxpos) {

  # Vector addition guarantee correct dimension
  fwd.mat <- sparseMatrix(
    i = c(basecounts$pos,maxpos),
    j = c(cells[basecounts$cellbarcode],1),
    x = c(basecounts$plus,0)
  )
  colnames(x = fwd.mat) <- names(x = cells)
  rownames(x = fwd.mat) <- paste(
    dna.base,
    seq_len(length.out = nrow(fwd.mat)),
    "fwd",
    sep = "-"
  )
  rev.mat <- sparseMatrix(
    i = c(basecounts$pos,maxpos),
    j = c(cells[basecounts$cellbarcode],1),
    x = c(basecounts$minus,0)
  )
  colnames(x = rev.mat) <- names(x = cells)
  rownames(x = rev.mat) <- paste(
    dna.base,
    seq_len(length.out = nrow(rev.mat)),
    "rev",
    sep = "-"
  )
  return(list(fwd.mat, rev.mat))
}

ReadMGATK <- function(dir, verbose = TRUE) {
  if (!dir.exists(paths = dir)) {
    stop("Directory not found")
  }
  a.path <- list.files(path = dir, pattern = "*.A.txt.gz", full.names = TRUE)
  c.path <- list.files(path = dir, pattern = "*.C.txt.gz", full.names = TRUE)
  t.path <- list.files(path = dir, pattern = "*.T.txt.gz", full.names = TRUE)
  g.path <- list.files(path = dir, pattern = "*.G.txt.gz", full.names = TRUE)

  refallele.path <- list.files(
    path = dir,
    pattern = "*_refAllele.txt*", # valid mtDNA contigs include chrM and MT
    full.names = TRUE
  )

  # The depth file lists all barcodes that were genotyped
  depthfile.path <- list.files(
    path = dir,
    pattern = "*.depthTable.txt",
    full.names = TRUE
  )

  if (verbose) {
    message("Reading allele counts")
  }
  column.names <- c("pos", "cellbarcode", "plus", "minus")
  a.counts <- read.table(
    file = a.path,
    sep = ",",
    header = FALSE,
    stringsAsFactors = FALSE,
    col.names = column.names
  )
  c.counts <- read.table(
    file = c.path,
    sep = ",",
    header = FALSE,
    stringsAsFactors = FALSE,
    col.names = column.names
  )
  t.counts <- read.table(
    file = t.path,
    sep = ",",
    header = FALSE,
    stringsAsFactors = FALSE,
    col.names = column.names
  )
  g.counts <- read.table(
    file = g.path,
    sep = ",",
    header = FALSE,
    stringsAsFactors = FALSE,
    col.names = column.names
  )

  if (verbose) {
    message("Reading metadata")
  }
  refallele <- read.table(
    file = refallele.path,
    header = FALSE,
    stringsAsFactors = FALSE,
    col.names = c("pos", "ref")
  )
  refallele$ref <- toupper(x = refallele$ref)
  depth <- read.table(
    file = depthfile.path,
    header = FALSE,
    stringsAsFactors = FALSE,
    col.names = c("cellbarcode", "mito.depth"),
    row.names = 1
  )
  cellbarcodes <- unique(x = rownames(depth))
  cb.lookup <- seq_along(along.with = cellbarcodes)
  names(cb.lookup) <- cellbarcodes

  if (verbose) {
    message("Building matrices")
  }

  maxpos <- dim(refallele)[1]
  a.mat <- SparseMatrixFromBaseCounts(
    basecounts = a.counts, cells = cb.lookup, dna.base = "A", maxpos = maxpos
  )
  c.mat <- SparseMatrixFromBaseCounts(
    basecounts = c.counts, cells = cb.lookup, dna.base = "C", maxpos = maxpos
  )
  t.mat <- SparseMatrixFromBaseCounts(
    basecounts = t.counts, cells = cb.lookup, dna.base = "T", maxpos = maxpos
  )
  g.mat <- SparseMatrixFromBaseCounts(
    basecounts = g.counts, cells = cb.lookup, dna.base = "G", maxpos = maxpos
  )

  counts <- rbind(a.mat[[1]], c.mat[[1]], t.mat[[1]], g.mat[[1]],
                  a.mat[[2]], c.mat[[2]], t.mat[[2]], g.mat[[2]])

  return(list("counts" = counts, "depth" = depth, "refallele" = refallele))
}

ProcessLetter <- function(
  object,
  letter,
  ref_alleles,
  coverage,
  stabilize_variance = TRUE,
  low_coverage_threshold = 10,
  verbose = TRUE
) {
  if (verbose) {
    message("Processing ", letter)
  }
  boo <- ref_alleles$ref != letter & ref_alleles$ref != "N"
  cov <- coverage[boo, ]

  variant_name <- paste0(
    as.character(ref_alleles$pos),
    ref_alleles$ref,
    ">",
    letter
  )[boo]

  nucleotide <- paste0(
    ref_alleles$ref,
    ">",
    letter
  )[boo]

  position_filt <- ref_alleles$pos[boo]

  # get forward and reverse counts
  fwd.counts <- GetMutationMatrix(
    object = object,
    letter = letter,
    strand = "fwd"
  )[boo, ]

  rev.counts <- GetMutationMatrix(
    object = object,
    letter = letter,
    strand = "rev"
  )[boo, ]

  # convert to row, column, value
  fwd.ijx <- summary(fwd.counts)
  rev.ijx <- summary(rev.counts)

  # get bulk coverage stats
  bulk <- (rowSums(fwd.counts + rev.counts) / rowSums(cov))
  # replace NA or NaN with 0
  bulk[is.na(bulk)] <- 0
  bulk[is.nan(bulk)] <- 0

  # find correlation between strands for cells with >0 counts on either strand
  # group by variant (row) and find correlation between strand depth
  both.strand <- data.table(cbind(fwd.ijx, rev.ijx$x))
  both.strand$i <- variant_name[both.strand$i]
  colnames(both.strand) <- c("variant", "cell_idx", "forward", "reverse")

  cor_dt <- suppressWarnings(expr = both.strand[, .(cor = cor(
    x = forward, y = reverse, method = "pearson", use = "pairwise.complete")
  ), by = list(variant)])

  # Put in vector for convenience
  cor_vec_val <- cor_dt$cor
  names(cor_vec_val) <- as.character(cor_dt$variant)

  # Compute the single-cell data
  mat <- (fwd.counts + rev.counts) / cov
  rownames(mat) <- variant_name
  # set NAs and NaNs to zero
  mat@x[!is.finite(mat@x)] <- 0

  # Stablize variances by replacing low coverage cells with mean
  if (stabilize_variance) {
    idx_mat <- which(cov < low_coverage_threshold, arr.ind = TRUE)
    idx_mat_mean <- bulk[idx_mat[, 1]]
    ones <- 1 - sparseMatrix(
      i = c(idx_mat[, 1], dim(x = mat)[1]),
      j = c(idx_mat[, 2], dim(x = mat)[2]),
      x = 1
    )
    means_mat <- sparseMatrix(
      i = c(idx_mat[, 1], dim(x = mat)[1]),
      j = c(idx_mat[, 2], dim(x = mat)[2]),
      x = c(idx_mat_mean, 0)
    )
    mmat2 <- mat * ones + means_mat
    variance <- SparseRowVar(x = mmat2)
  } else {
    variance <- SparseRowVar(x = mat)
  }
  detected <- (fwd.counts >= 2) + (rev.counts >= 2)

  # Compute per-mutation summary statistics
  var_summary_df <- data.frame(
    position = position_filt,
    nucleotide = nucleotide,
    variant = variant_name,
    vmr = variance / (bulk + 0.00000000001),
    mean = round(x = bulk, digits = 7),
    variance = round(x = variance, digits = 7),
    n_cells_conf_detected = rowSums(x = detected == 2),
    n_cells_over_5 = rowSums(x = mat >= 0.05),
    n_cells_over_10 = rowSums(x = mat >= 0.10),
    n_cells_over_20 = rowSums(x = mat >= 0.20),
    strand_correlation = cor_vec_val[variant_name],
    mean_coverage = rowMeans(x = cov),
    stringsAsFactors = FALSE,
    row.names = variant_name
  )
  return(var_summary_df)
}

GetMutationMatrix <- function(object, letter, strand) {
  keep.rows <- paste(
    letter,
    seq_len(length.out = nrow(x = object) / 8),
    strand,
    sep = "-"
  )
  return(object[keep.rows, ])
}

ComputeTotalCoverage <- function(object, verbose = TRUE) {
  if (verbose) {
    message("Computing total coverage per base")
  }
  rowstep <- nrow(x = object) / 8
  mat.list <- list()
  for (i in seq_len(length.out = 8)) {
    mat.list[[i]] <- object[(rowstep * (i - 1) + 1):(rowstep * i), ]
  }
  coverage <- Reduce(f = `+`, x = mat.list)
  coverage <- as.matrix(x = coverage)
  rownames(x = coverage) <- seq_along(along.with = rownames(x = coverage))
  return(coverage)
}

IdentifyVariants <- function(
  object,
  refallele,
  stabilize_variance = TRUE,
  low_coverage_threshold = 10,
  verbose = TRUE,
  ...
) {
  coverages <- ComputeTotalCoverage(object = object, verbose = verbose)
  a.df <- ProcessLetter(
    object = object,
    letter = "A",
    coverage = coverages,
    ref_alleles = refallele,
    stabilize_variance = stabilize_variance,
    low_coverage_threshold = low_coverage_threshold,
    verbose = verbose
  )
  t.df <- ProcessLetter(
    object = object,
    letter = "T",
    coverage = coverages,
    ref_alleles = refallele,
    stabilize_variance = stabilize_variance,
    low_coverage_threshold = low_coverage_threshold,
    verbose = verbose
  )
  c.df <- ProcessLetter(
    object = object,
    letter = "C",
    coverage = coverages,
    ref_alleles = refallele,
    stabilize_variance = stabilize_variance,
    low_coverage_threshold = low_coverage_threshold,
    verbose = verbose
  )
  g.df <- ProcessLetter(
    object = object,
    letter = "G",
    coverage = coverages,
    ref_alleles = refallele,
    stabilize_variance = stabilize_variance,
    low_coverage_threshold = low_coverage_threshold,
    verbose = verbose
  )
  return(rbind(a.df, t.df, c.df, g.df))
}

tmp <- ReadMGATK(file.path(options$input))
variable.sites <- IdentifyVariants(tmp$counts, refallele = tmp$refallele)
high.conf <- subset(variable.sites, subset = (n_cells_conf_detected >= options$n_cells_conf_detected & strand_correlation >= options$strand_correlation & vmr > options$vmr))

var.pos <- high.conf %>%
  dplyr::mutate(pos1=gsub('([0-9]*)([ACGT])>([ACGT])','\\2-\\1-fwd',variant),
                pos2=gsub('([0-9]*)([ACGT])>([ACGT])','\\3-\\1-fwd',variant),
                pos3=gsub('([0-9]*)([ACGT])>([ACGT])','\\2-\\1-rev',variant),
                pos4=gsub('([0-9]*)([ACGT])>([ACGT])','\\3-\\1-rev',variant)) %>% 
  dplyr::select(pos1,pos2,pos3,pos4) %>% 
  gather(p,pos) %>% 
  dplyr::pull(pos)

write.table(var.pos,file.path(options$output,'genes.tsv'),
            col.names=FALSE,row.names=FALSE,quote=FALSE)
writeMM(tmp$counts[var.pos,],file.path(options$output,'matrix.mtx'))
write.table(colnames(tmp$counts),file.path(options$output,'barcodes.tsv'),
            row.names=FALSE,col.names=FALSE,quote=FALSE)

#!/usr/bin/env Rscript
suppressMessages(suppressWarnings(library(data.table)))
suppressMessages(suppressWarnings(library(ggrepel)))
suppressMessages(suppressWarnings(library(ggplot2)))
suppressMessages(suppressWarnings(library(dplyr)))

options(warn=-1)

if(FALSE){
  clip_file <- "/Users/clareau/dat/Research/AryeeResearch/lareau_dev/mgatk/tests/barcode/pearson_bci_del6073-13095.clip.tsv"
}

#-----------------
# Command line i/o
#-----------------
args <- commandArgs(trailingOnly = TRUE)
clip_file <- args[1]
SA_file <- args[2]

# positions that are frequently clipped
blacklist <- c(1,296,299,300,301,3108,3564,3571,10934,13753,13760,16569)

# read clip file, message to include position and sort by most frequently clipped
df <- fread(clip_file, col.names=c("pos", "coverage", "clipped", "SA"), header = TRUE) %>%
  mutate(blacklist = factor(ifelse(pos %in% blacklist, TRUE,FALSE))) %>%
  mutate(clipped = ifelse(pos == 1 | pos == 16569, 0, clipped)) %>%
  arrange(-clipped) %>%
  mutate(bin = as.numeric(cut(pos, breaks=34)))

# summarise per bin for segment mean plot on top of coverage
df2 <- df %>%
  group_by(bin) %>%
  summarise(mean = mean(coverage),
            start = min(pos),
            end = max(pos))

# plot barplot of number of clipped reads per position
# label top 10 most freq. clip positions
# color in red positions which are frequently clipped in all samples
p1 <- ggplot(df, aes(x = pos, y = clipped)) +
  geom_col(aes(fill = blacklist), width = 50,
           show.legend = FALSE) +
  scale_fill_manual(values=c("black", "lightgrey")) +
  geom_label_repel(
    data = df[1:10,],
    aes(label = pos, color = blacklist),
    size = 2,
    show.legend = FALSE) +
  scale_color_manual(values=c("black", "lightgrey")) +
  theme_bw() +
  xlab("position") +
  ylab("# of clipped reads")

# plot coverage as a line graph without smoothing
# plot segments of ~500bps with mean coverage over region
p2 <- ggplot() +
  geom_line(df, mapping = aes(x = pos, y = coverage, alpha = 0.2),
            show.legend = F) +
  xlab("position") +
  ylab("Read depth") +
  geom_segment(df2, mapping=aes(x=start, y=mean, xend=end, yend=mean)) +
  theme_bw()

# find ±2 of all positions (between 0:16569) with SA > 0 

pos <- function(position){
  pos = position + -2:2
  return(data.frame(pos=pos))
}

SA_positions=lapply((df  %>% filter(SA!=0))$pos, pos) %>% bind_rows() %>% filter(pos < 16569 & pos > 1) %>% unique()

# color: 1 if in blacklist, 3 if in SA_positions but not in blacklist, else 2
df3 = df %>% mutate(SA_sup = case_when(pos %in% SA_positions$pos ~ T, TRUE~ F))%>%
  mutate(color= case_when(SA_sup==TRUE & (blacklist==F) ~3, blacklist==T ~1, TRUE ~ 2)) %>% 
  arrange(-SA) %>% arrange(-clipped) %>% ungroup() %>%
  mutate(clipped = ifelse(pos == 1 | pos == 16569, 0, clipped)) 

# updates
SA = fread(SA_file) %>%
  mutate(out3 = case_when(out2 > out1 ~ out1, out1 >= out2 ~ out2)) %>%
  mutate(out4 = case_when(out1 > out2 ~ out1, out2 >= out1 ~ out2)) %>%
  subset(., select=-c(out1,out2)) %>% setNames(c('main', 'SA')) %>% arrange(-main) %>%
  group_by(SA, main) %>% add_tally() %>% 
  filter(n>1) %>% unique()

SA <- SA %>% filter(!(SA %in% blacklist) & !(main %in% blacklist)) %>% 
  setNames(c('position', 'supp_A', 'weight'))

p3 = ggplot(df3, aes(x = pos, y = clipped)) +
  geom_col(aes(fill = as.factor(color)), width = 50,
           show.legend = FALSE) +
  scale_fill_manual(values=c("lightgrey", "black", "red")) +
  geom_label_repel(
    data = (df3 %>% arrange(-SA))[1:4,],
    aes(label = pos, color = as.factor(color)),
    size = 2,
    show.legend = FALSE) +
  scale_color_manual(values=c("lightgrey", "black", "red")) +
  theme_bw() + theme(legend.position = "none")+
  xlab("position") +
  ylab("# of clipped reads") +
  geom_curve(aes(x = position, y = 0, xend = supp_A, yend = 0, alpha=weight), show.legend = TRUE,curvature=-0.5,data = SA)

# save combined plot 
out_base <- gsub(".clip.tsv","",clip_file)
ggsave(p1, file = paste0(out_base,".clipped_viz.pdf"), height = 4, width = 7)
ggsave(p2, file = paste0(out_base,".coverage_viz.pdf"), height = 4, width = 7)
ggsave(p3, file = paste0(out_base,".SA_coverage_viz.pdf"), height = 4, width = 7)

library(dplyr)
library(Matrix)
library(tidyr)
library(optparse)
library(SummarizedExperiment)

option_list <- list(
  make_option(c("-i","--input"),type="character",help="input MGATK directory",metavar="file"),
  make_option(c("-c","--cellbender_h5"),type="character",help="cellbender output file (all cells!)",metavar="file"),
  make_option(c("-o","--output"),type="character",help="output file with filtered counts",metavar="file"),
  make_option("--cells",type="character",help="barcodes.tsv file with accepted cell barcodes",metavar="file")
)

opt_parser <- OptionParser(option_list = option_list)
options <- parse_args(opt_parser)

if (is.null(options$input)) {
  print_help(opt_parser)
  stop("please supply input directory",call.=FALSE)
}

if (is.null(options$output)) {
  print_help(opt_parser)
  stop("please supply output directory",call.=FALSE)
}

if (is.null(options$cellbender_h5)) {
  print_help(opt_parser)
  stop("please supply output directory",call.=FALSE)
}

ReadCB_h5 <- function(filename, use.names = TRUE, unique.features = TRUE) {
  if (!requireNamespace('hdf5r', quietly = TRUE)) {
    stop("Please install hdf5r to read HDF5 files")
  }
  if (!file.exists(filename)) {
    stop("File not found")
  }
  infile <- hdf5r::H5File$new(filename = filename, mode = 'r')
  genomes <- names(x = infile)
  output <- list()
  if (hdf5r::existsGroup(infile, 'matrix')) {
    # cellranger version 3
    if (use.names) {
      feature_slot <- 'features/name'
    } else {
      feature_slot <- 'features/id'
    }
  } else {
    if (use.names) {
      feature_slot <- 'gene_names'
    } else {
      feature_slot <- 'genes'
    }
  }
  for (genome in genomes) {
    counts <- infile[[paste0(genome, '/data')]]
    indices <- infile[[paste0(genome, '/indices')]]
    indptr <- infile[[paste0(genome, '/indptr')]]
    shp <- infile[[paste0(genome, '/shape')]]
    features <- infile[[paste0(genome, '/', feature_slot)]][]
    barcodes <- infile[[paste0(genome, '/barcodes')]]
    sparse.mat <- sparseMatrix(
      i = indices[] + 1,
      p = indptr[],
      x = as.numeric(x = counts[]),
      dims = shp[],
      giveCsparse = FALSE
    )
    if (unique.features) {
      features <- make.unique(names = features)
    }
    rownames(x = sparse.mat) <- features
    colnames(x = sparse.mat) <- barcodes[]
    sparse.mat <- as(object = sparse.mat, Class = 'dgCMatrix')
    # Split v3 multimodal
    if (infile$exists(name = paste0(genome, '/features'))) {
      types <- infile[[paste0(genome, '/features/feature_type')]][]
      types.unique <- unique(x = types)
      if (length(x = types.unique) > 1) {
        message("Genome ", genome, " has multiple modalities, returning a list of matrices for this genome")
        sparse.mat <- sapply(
          X = types.unique,
          FUN = function(x) {
            return(sparse.mat[which(x = types == x), ])
          },
          simplify = FALSE,
          USE.NAMES = TRUE
        )
      }
    }
    output[[genome]] <- sparse.mat
  }
  infile$close_all()
  if (length(x = output) == 1) {
    return(output[[genome]])
  } else{
    return(output)
  }
}

SparseMatrixFromBaseCounts <- function(basecounts, cells, dna.base, maxpos) {

  # Vector addition guarantee correct dimension
  fwd.mat <- sparseMatrix(
    i = c(basecounts$pos,maxpos),
    j = c(cells[basecounts$cellbarcode],1),
    x = c(basecounts$plus,0)
  )
  colnames(x = fwd.mat) <- names(x = cells)
  rownames(x = fwd.mat) <- paste(
    dna.base,
    seq_len(length.out = nrow(fwd.mat)),
    "fwd",
    sep = "-"
  )
  rev.mat <- sparseMatrix(
    i = c(basecounts$pos,maxpos),
    j = c(cells[basecounts$cellbarcode],1),
    x = c(basecounts$minus,0)
  )
  colnames(x = rev.mat) <- names(x = cells)
  rownames(x = rev.mat) <- paste(
    dna.base,
    seq_len(length.out = nrow(rev.mat)),
    "rev",
    sep = "-"
  )
  return(list(fwd.mat, rev.mat))
}

ReadMGATK <- function(dir, verbose = TRUE) {

  if (!dir.exists(paths = dir)) {
    stop("Directory not found")
  }
  a.path <- list.files(path = dir, pattern = "*.A.txt.gz", full.names = TRUE)
  c.path <- list.files(path = dir, pattern = "*.C.txt.gz", full.names = TRUE)
  t.path <- list.files(path = dir, pattern = "*.T.txt.gz", full.names = TRUE)
  g.path <- list.files(path = dir, pattern = "*.G.txt.gz", full.names = TRUE)

  refallele.path <- list.files(
    path = dir,
    pattern = "*_refAllele.txt*", # valid mtDNA contigs include chrM and MT
    full.names = TRUE
  )

  # The depth file lists all barcodes that were genotyped
  depthfile.path <- list.files(
    path = dir,
    pattern = "*.depthTable.txt",
    full.names = TRUE
  )

  if (verbose) {
    message("Reading allele counts")
  }
  column.names <- c("pos", "cellbarcode", "plus", "minus")
  a.counts <- read.table(
    file = a.path,
    sep = ",",
    header = FALSE,
    stringsAsFactors = FALSE,
    col.names = column.names
  )
  c.counts <- read.table(
    file = c.path,
    sep = ",",
    header = FALSE,
    stringsAsFactors = FALSE,
    col.names = column.names
  )
  t.counts <- read.table(
    file = t.path,
    sep = ",",
    header = FALSE,
    stringsAsFactors = FALSE,
    col.names = column.names
  )
  g.counts <- read.table(
    file = g.path,
    sep = ",",
    header = FALSE,
    stringsAsFactors = FALSE,
    col.names = column.names
  )

  if (verbose) {
    message("Reading metadata")
  }
  refallele <- read.table(
    file = refallele.path,
    header = FALSE,
    stringsAsFactors = FALSE,
    col.names = c("pos", "ref")
  )
  refallele$ref <- toupper(x = refallele$ref)
  depth <- read.table(
    file = depthfile.path,
    header = FALSE,
    stringsAsFactors = FALSE,
    col.names = c("cellbarcode", "mito.depth"),
    row.names = 1
  )
  cellbarcodes <- unique(x = rownames(depth))
  cb.lookup <- seq_along(along.with = cellbarcodes)
  names(cb.lookup) <- cellbarcodes

  if (verbose) {
    message("Building matrices")
  }

  maxpos <- dim(refallele)[1]
  a.mat <- SparseMatrixFromBaseCounts(
    basecounts = a.counts, cells = cb.lookup, dna.base = "A", maxpos = maxpos
  )
  c.mat <- SparseMatrixFromBaseCounts(
    basecounts = c.counts, cells = cb.lookup, dna.base = "C", maxpos = maxpos
  )
  t.mat <- SparseMatrixFromBaseCounts(
    basecounts = t.counts, cells = cb.lookup, dna.base = "T", maxpos = maxpos
  )
  g.mat <- SparseMatrixFromBaseCounts(
    basecounts = g.counts, cells = cb.lookup, dna.base = "G", maxpos = maxpos
  )

  counts <- rbind(a.mat[[1]], c.mat[[1]], t.mat[[1]], g.mat[[1]],
                  a.mat[[2]], c.mat[[2]], t.mat[[2]], g.mat[[2]])

  return(list("counts" = counts, "depth" = depth, "refallele" = refallele))
}

raw <- ReadMGATK(file.path(options$input))
rc <- raw$counts
CB <- ReadCB_h5(options$cellbender_h5)
pos <- intersect(row.names(rc),row.names(CB))
cells <- intersect(colnames(rc),colnames(CB))

# if --cells is specified, restrict to those cells
if (!is.null(options$cells)) {
   barcodes <- read.table(options$cells,header=FALSE,row.names=NULL)
   cells <- intersect(cells,barcodes[,1])
}

rc <- rc[,cells]
# replace raw values by cellbender estimates
rc[pos,cells] <- CB[pos,cells]

# at this point we probably should ensure that zero counts on one strand with non-zero counts on the other are actually zero and not NA; otherwise this triggers an error in Signac: https://github.com/timoast/signac/blob/2e4e18354297adc4b069b48a7794aa1efed35016/R/mito.R#L603
assays <- list()
for (let in c('A','C','G','T')) {
  assays[[paste0(let,'_counts_fw')]] <- rc[grepl(paste0(let,'-[0-9]*-fwd'),row.names(rc)),]
  row.names(assays[[paste0(let,'_counts_fw')]]) <- raw$refallele$pos
  assays[[paste0(let,'_counts_rev')]] <- rc[grepl(paste0(let,'-[0-9]*-rev'),row.names(rc)),]
  row.names(assays[[paste0(let,'_counts_rev')]]) <- raw$refallele$pos
}
assays[['coverage']] <- Reduce('+', assays)
tmp <- SummarizedExperiment(assays=assays,
                            colData=data.frame(sample=colnames(rc),
                              depth=Matrix::colSums(rc)/(dim(rc)[1]/8)),
                            rowData=data.frame(refAllele=raw$refallele$ref,
                              row.names=raw$refallele$pos))

saveRDS(tmp, options$output)

## mgatk python dev notes
**Caleb Lareau**

### DAG

To visualize the DAG associated with the `snakemake` file, do the following--

```
1) Modify the Snakefile.Scatter to 
2) Run a basic mgatk command (e.g. mgatk call -i tests/humanbam -o tests/outbam)
```

This will generate some plaintext that looks something like this:

```
digraph snakemake_dag {
    graph[bgcolor=white, margin=0];
    node[shape=box, style=rounded, fontname=sans,                 fontsize=10, penwidth=2];
    edge[penwidth=2, color=grey];
	0[label = "all", color = "0.40 0.6 0.85", style="rounded"];
	1[label = "make_depth_table", color = "0.13 0.6 0.85", style="rounded"];
	2[label = "call_variants", color = "0.53 0.6 0.85", style="rounded"];
	3[label = "get_depth_bq_baq", color = "0.27 0.6 0.85", style="rounded"];
	4[label = "filter_sort", color = "0.00 0.6 0.85", style="rounded"];
	1 -> 0
	2 -> 0
	3 -> 1
	4 -> 2
	4 -> 3
}     
```

So dump those contents into a text file, say, `dag.txt`. Finally, run--

```
cat dag.txt | dot -Tsvg > dag.svg
```
to visualize the dag. 
<br><br>
